{
   demo program to compare comb sort with quick sort
}
program sort(output);

const
   maxIndex = 12000;
   maxNum =  maxint;
type
   index     = 1..maxIndex;
   testArray =  packed array [index] of 0..maxNum;

var a,b,c   : testArray;
   nswaps : integer;

{initialise test array with random data}
function rand: integer; external;
procedure initialise;

var
   c : char;
   i : integer;
begin
   for i := 1 to maxIndex do begin
      a[i] := rand mod maxNum;
   end; {for}
end; { initialise }

function compare(a1, a2 :  testArray): boolean;
var
   i  : index;
   eq : boolean;
begin
   eq := true;
   i := 1;
   repeat
      if a1[i] <> a2[i] then
         eq := false;
      if i <> maxIndex then
         i := i + 1;
   until (i = maxIndex) or not eq;
   compare := eq;
end; { compare }

procedure quicksort(l, r: index);

var i, j: index;
    x, w: 0..maxNum;

z: integer;

begin

    i := l;
    j := r;
    x := a[(l+r) div 2];
    repeat

        while a[i] < x do i := i+1;
        while x < a[j] do j := j-1;
        if i <= j then begin
            nswaps := nswaps+1;
            w := a[i]; a[i] := a[j]; a[j] := w;
            i := i+1;
            j := j-1

        end

    until i > j;
    if l < j then quicksort(l, j);
    if i < r then quicksort(i, r);

end; {quicksort}


procedure combsort(size: index);

var
   i     : index;
   w     : 0..maxNum;
   gap   :integer;
   sorting  : boolean;

begin

   gap := size; {initial gap size}
   sorting := true;

   while (gap > 1) or sorting do begin
      { reduce gap by shrink factor}
      if gap in [12..14] then
         gap := 11         {optimise last few loops}
      else if gap > 1 then begin
         gap := (gap*10) div 13;
      end;

      sorting := false;

      for i := 1 to size-gap do begin {compare elements with gap}
         if a[i] > a[i+gap] then begin
            nswaps := nswaps+1;
            w := a[i];
            a[i] := a[i+gap];
            a[i+gap] := w;
            sorting := true;
         end; {if}
      end; {for}
   end; {while}

end; {combsort}


begin

    nswaps := 0;
    initialise;
    b := a;
    quicksort(1, maxIndex);
    writeln('quicksort nswaps is ', nswaps);
    c := a;

    nswaps := 0;
    a := b;
    combsort(maxIndex);
    writeln('combsort nswaps is ', nswaps);

   if compare(a,c) then
      writeln('they agree')
   else
      writeln('they disagree');

end.
