{%%%%%%%%% Copyright (c) 2020 Trevor Blight All rights reserved. %%%%%%%%%

   find whether memory allocated at given line is not free
   useful function for tracking memory leaks

   usage:
   say test run of myProg with debug build reports that memory at line 1234 was not disposed
   put a call like this at some suitable lacation(s) in myProg:

   if memcheck(1234) then
      writeln('line', __LINR__:1, ': memory at line 1234 has not been freed');

   note:
   memory debuging must be enabled, ie debugging must not be disabled at the program header in myProg
}

{ return true if memory allocated at line is valid
         false if there is no memory allocated at that line number or it has been freed
}
function memCheck(lineNr : integer): boolean;
begin
{@@ #if defined MEMDEBUG @@}
{@@
     int check1( struct _Pmem *const p )
     {
          if( p == NULL ) return 0;
          if( ! check1( p->left ) )
               if( p->f == 0 && p->line == @@lineNr)
                    return 1;
          return check1( p->right );
     }
     return check1(_Proot);
@@}
{@@ #endif @@}

   memCheck := false;

end;  //_Pcheck_mem()

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%% end of memcheck.inc.pas %%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
