{: test that overflow in constant integer expressions causes a
   compilation error }

program e082( output );

var
   i, k : integer;
   x    : real;

begin {e082}

   x := -maxint; x := x - 1;  {OK}
   x := -x;           {OK}

   write( 'checking for -(-maxint-1) overflow, expect error ... ' );
   k := -maxint; {OK}
   k := -maxint - 1; {!!! = -maxint - 1 ==> possible overflow}
   k := -(-maxint - 1); {!!! = -(-maxint - 1) ==> overflow}

   k := -1 - maxint; {!!! = -1 - -maxint ==> possible overflow}
   k := -(-1 - maxint - 1); {!!! = -(-1 - maxint) ==> overflow}


   { test integer plus }
   k := (-maxint-1) + (-maxint-1) ; {!!! underflow }
   k := (-maxint-1) + (-maxint) ; {!!! underflow }
   k := (-maxint-1) + (-1) ; {!!! underflow }
   k := (-maxint-1) + 0 ; { OK }
   k := (-maxint-1) + 1 ; { OK }
   k := (-maxint-1) + maxint ; { OK }
   k := (-maxint) + (-maxint-1) ; {!!! underflow }
   k := (-maxint) + (-maxint) ; {!!! underflow }
   k := (-maxint) + (-1) ; { OK }
   k := (-maxint) + 0 ; { OK }
   k := (-maxint) + 1 ; { OK }
   k := (-maxint) + maxint ; { OK }
   k := (-1) + (-maxint-1) ; {!!! underflow }
   k := (-1) + (-maxint) ; { OK }
   k := (-1) + (-1) ; { OK }
   k := (-1) + 0 ; { OK }
   k := (-1) + 1 ; { OK }
   k := (-1) + maxint ; { OK }
   k := 0 + (-maxint-1) ; { OK }
   k := 0 + (-maxint) ; { OK }
   k := 0 + (-1) ; { OK }
   k := 0 + 0 ; { OK }
   k := 0 + 1 ; { OK }
   k := 0 + maxint ; { OK }
   k := 1 + (-maxint-1) ; { OK }
   k := 1 + (-maxint) ; { OK }
   k := 1 + (-1) ; { OK }
   k := 1 + 0 ; { OK }
   k := 1 + 1 ; { OK }
   k := 1 + maxint ; {!!! overflow }
   k := maxint + (-maxint-1) ; { OK }
   k := maxint + (-maxint) ; { OK }
   k := maxint + (-1) ; { OK }
   k := maxint + 0 ; { OK }
   k := maxint + 1 ; {!!! overflow }
   k := maxint + maxint ; {!!! overflow }


   { test integer subtract }
   k := (-maxint-1) - (-maxint-1) ; { OK }
   k := (-maxint-1) - (-maxint) ; { OK }
   k := (-maxint-1) - (-1) ; { OK }
   k := (-maxint-1) - 0 ; { OK }
   k := (-maxint-1) - 1 ; {!!! underflow }
   k := (-maxint-1) - maxint ; {!!! underflow }
   k := (-maxint) - (-maxint-1) ; { OK }
   k := (-maxint) - (-maxint) ; { OK }
   k := (-maxint) - (-1) ; { OK }
   k := (-maxint) - 0 ; { OK }
   k := (-maxint) - 1 ; { OK }
   k := (-maxint) - maxint ; {!!! underflow }
   k := (-1) - (-maxint-1) ; { OK }
   k := (-1) - (-maxint) ; { OK }
   k := (-1) - (-1) ; { OK }
   k := (-1) - 0 ; { OK }
   k := (-1) - 1 ; { OK }
   k := (-1) - maxint ; { OK }
   k := 0 - (-maxint-1) ; {!!! overflow }
   k := 0 - (-maxint) ; { OK }
   k := 0 - (-1) ; { OK }
   k := 0 - 0 ; { OK }
   k := 0 - 1 ; { OK }
   k := 0 - maxint ; { OK }
   k := 1 - (-maxint-1) ; {!!! overflow }
   k := 1 - (-maxint) ; {!!! overflow }
   k := 1 - (-1) ; { OK }
   k := 1 - 0 ; { OK }
   k := 1 - 1 ; { OK }
   k := 1 - maxint ; { OK }
   k := maxint - (-maxint-1) ; {!!! overflow }
   k := maxint - (-maxint) ; {!!! overflow }
   k := maxint - (-1) ; {!!! overflow }
   k := maxint - 0 ; { OK }
   k := maxint - 1 ; { OK }
   k := maxint - maxint ; { OK }

   { test integer multiply }
   { assuming 32 bit integers, test values need correcting otherwise
     here we use maxint+2 = 3 * 715827883
   }
   if maxint <> 2147483647 then
      writeln( 'warning: some test results may be invalid' );

   k := (-maxint-1) * (-maxint-1); {!!! overflow }
   k := (-maxint-1) * (-maxint); {!!! overflow }
   k := (-maxint-1) * (-715827883); {!!! overflow }
   k := (-maxint-1) * (-1); {!!! overflow }
   k := (-maxint-1) * 0; { OK }
   k := (-maxint-1) * 1; { OK }
   k := (-maxint-1) * 3; {!!! underflow }
   k := (-maxint-1) * maxint; {!!! underflow }
   k := (-maxint) * (-maxint-1); {!!! overflow }
   k := (-maxint) * (-maxint); {!!! overflow }
   k := (-maxint) * (-715827883); {!!! overflow }
   k := (-maxint) * (-1); { OK }
   k := (-maxint) * 0; { OK }
   k := (-maxint) * 1; { OK }
   k := (-maxint) * 3; {!!! underflow }
   k := (-maxint) * maxint; {!!! underflow }
   k := (-715827883) * (-maxint-1); {!!! overflow }
   k := (-715827883) * (-maxint); {!!! overflow }
   k := (-715827883) * (-715827883); {!!! overflow }
   k := (-715827883) * (-1); { OK }
   k := (-715827883) * 0; { OK }
   k := (-715827883) * 1; { OK }
   k := (-715827883) * 3; {!!! underflow }
   k := (-715827883) * maxint; {!!! underflow }
   k := (-1) * (-maxint-1); {!!! overflow }
   k := (-1) * (-maxint); { OK }
   k := (-1) * (-715827883); { OK }
   k := (-1) * (-1); { OK }
   k := (-1) * 0; { OK }
   k := (-1) * 1; { OK }
   k := (-1) * 3; { OK }
   k := (-1) * maxint; { OK }
   k := 0 * (-maxint-1); { OK }
   k := 0 * (-maxint); { OK }
   k := 0 * (-715827883); { OK }
   k := 0 * (-1); { OK }
   k := 0 * 0; { OK }
   k := 0 * 1; { OK }
   k := 0 * 3; { OK }
   k := 0 * maxint; { OK }
   k := 1 * (-maxint-1); { OK }
   k := 1 * (-maxint); { OK }
   k := 1 * (-715827883); { OK }
   k := 1 * (-1); { OK }
   k := 1 * 0; { OK }
   k := 1 * 1; { OK }
   k := 1 * 3; { OK }
   k := 1 * maxint; { OK }
   k := 3 * (-maxint-1); {!!! underflow }
   k := 3 * (-maxint); {!!! underflow }
   k := 3 * (-715827883); {!!! underflow }
   k := 3 * (-1); { OK }
   k := 3 * 0; { OK }
   k := 3 * 1; { OK }
   k := 3 * 3; { OK }
   k := 3 * maxint; {!!! overflow }
   k := maxint * (-maxint-1); {!!! underflow }
   k := maxint * (-maxint); {!!! underflow }
   k := maxint * (-715827883); {!!! underflow }
   k := maxint * (-1); { OK }
   k := maxint * 0; { OK }
   k := maxint * 1; { OK }
   k := maxint * 3; {!!! overflow }
   k := maxint * maxint; {!!! overflow }
   k := 32768 * 65536; {!!! overflow }
   k := (-32768) * (-65536); {!!! overflow }
   k := 32768 * (-65536); { OK }
   k := (-32768) * 65536; { OK }


   { test integer divide }
   k := (-maxint-1) div (-1); {!!! overflow }
   k := (-maxint-1) div 1; { OK }
   k := (-maxint) div (-1); { OK }
   k := (-maxint) div 1; { OK }
   k := (maxint) div (-1); { OK }
   k := (maxint) div 1; { OK }


   {assuming 32 bit integers ...}
   k := 2147483647;     {OK}
   k := -2147483647;    {OK}
   k := 2147483648;     {!!! overflows}
   k := -2147483648;    {possible overflow or OK}
   k := -2147483649;    {!!! overflows}
   k := -(-2147483648); {!!! overflows}

   k := (maxint - 10) + 10; {OK}
   k := (maxint - 10) + 11; {!!! overflow}

   k := (-maxint + 10) - 10; {OK}
   k := (-maxint + 10) - 11; {OK}
   k := (-maxint + 10) - 12; {!!! overflow}

   k := (maxint - 10) - (-10); {OK}
   k := (maxint - 10) - (-11); {!!! overflow}

   k := (-maxint + 10) + (-10); {OK}
   k := (-maxint + 10) + (-11); {OK}
   k := (-maxint + 10) + (-12); {!!! overflow}

   k := 10 + (maxint - 10); {OK}
   k := 11 + (maxint - 10); {!!! overflow}

   k := -10 + (-maxint + 10); {OK}
   k := -11 + (-maxint + 10); {OK}
   k := -12 + (-maxint + 10); {!!! overflow}

   k := 10 - (10 - maxint); {OK}
   k := 11 - (10 - maxint); {!!! overflow}

   k := (-10) + (-maxint + 10); {OK}
   k := (-11) + (-maxint + 10); {OK}
   k := (-12) + (-maxint + 10); {!!! overflow}

   k := (maxint div 10) * 10; {OK}
   k := (maxint div 10) * 11; {!!! overflow}

   k := (maxint div 10) * (-10); {OK}
   k := (maxint div 10) * (-11); {!!! overflow}

   k := ((-maxint) div 10) * 10; {OK}
   k := ((-maxint) div 10) * 11; {!!! overflow}

   k := ((-maxint) div 10) * (-10); {OK}
   k := ((-maxint) div 10) * (-11); {!!! overflow}

   writeln;
   write( '-(-maxint-1) overflow not detected, result is ' );
   if i+1 = -maxint then writeln( '-maxint-1' )
   else writeln( i:1 );

end. { e082 }

